package lab7;

public class FibMaker extends Thread {
    
    private final int limit;
    private final Queue<Integer> queue;

    public FibMaker(int limit, Queue<Integer> queue) {
        this.limit = limit;
        this.queue = queue;
    }
    
    @Override
    public void run() {
        int a = 0;
        int b = 1;
        while (b<=limit) {
            queue.push(a);
            int h = a;
            a = b;
            b = h + b;
        }
        queue.push(a);
        queue.close();
    }
    
}
