package lab7;

public class Filter<E extends Comparable> implements Runnable {
    
    private final Queue<E> queue1;
    private final Queue<E> queue2;

    public Filter(Queue<E> queue1, Queue<E> queue2) {
        this.queue1 = queue1;
        this.queue2 = queue2;
    }
    
    @Override
    public void run() {
        E x = queue1.pull();
        E y = queue2.pull();
	while (x != null && y != null) {
            if (x.equals(y)) {
                System.out.println(x);
                x = queue1.pull();
                y = queue2.pull();
            } else {
                if (x.compareTo(y) < 0) {
                    x = queue1.pull();
                } else {
                    y = queue2.pull();
                }
            }
        }
        System.out.println("All values printed.");
    }
    
}
