package lab7;

import java.util.Arrays;

public class PrimeMaker extends Thread {
    
    private final int limit;
    private final Queue<Integer> queue;

    public PrimeMaker(int limit, Queue<Integer> queue) {
        this.limit = limit;
        this.queue = queue;
    }
    
    @Override
    public void run() {
        boolean[] sieve = new boolean[limit-1];
        for(int i=0; i<limit-1; i++) {
            sieve[i] = true;
        }
        int number = 2;
        while (number<=limit) {
            queue.push(number);
            int mult = 2;
            while (number*mult<=limit) {
                sieve[number*mult-2] = false;
                mult++;
            }
            number++;
            while (number-1<limit && !sieve[number-2]) {
                number++;
            }
        }
        queue.close();
    }
    
}
